/* bepaal de ouderdom van een file (afgerond) */
/* de leeftijd wordt geretourneerd als errorlevel */

/* (c) 1993-2000 Michiel van der Vlist, PA0MMV (2:280/5555) */

#define VERSION "v 1.3"
#define MYNAME "Michiel van der Vlist (2:280/5555)"

#include <io.h>
#include <time.h>
#include <dos.h>/
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <values.h>
#include <ctype.h>
#include <string.h>

int main(int argc, char *argv[])
{
	struct ftime ftimep;
	struct date fdate;
	struct time ftime;
	time_t timer;
	long age,filetime,fileage,days,hours,minutes;
	int n=0, smhd=0, fhandle, numberlength=0;
	char s[10], formatstring[20];
	FILE *log;

	if (argc==1 || (argc>1 && argv[1][0]=='?'))
	{
		printf("Getage %s by %s\n",VERSION,MYNAME);
		printf("Returns the age of a file as an errorlevel.\n\n");
		printf("Usage: getage [option [option]..] filename [logfilename]\n\n");
		printf("Options:\n");
		printf(" -d     return value in days.  (default)\n");
		printf(" -h     return value in hours.\n");
		printf(" -m     return value in minutes.\n");
		printf(" -s     return value in seconds.\n");
		printf(" -<n>   specify number of digits for result.\n");
		return(0);
	}
	if (argc>1)
	{
		while (argv[n+1][0]=='-')
		{
			n++;
			if (isdigit(argv[n][1]))
			{
				sscanf(&argv[n][1],"%d",&numberlength);
				if (numberlength>10) numberlength=0;
			}
			else
			{
				switch(toupper(argv[1][1]))
				{
					case	'D' :	smhd=0; break;
					case	'H' :	smhd=1; break;
					case	'M' :	smhd=2; break;
					case	'S' : smhd=3; break;
					default   :	smhd=-1; break;
				}
				if (smhd<0)
				{
					printf("Illegal option %s\n",argv[1]);
					return(0);
				}
			}
		}
	}
	if (argc<2+n)
	{
		printf("A file name must be specified.\n");
		return(0);
	}
	fhandle=open(argv[n+1],O_RDONLY);
	if (fhandle==-1)
	{
		printf("File not found.\n");
		return(0);
	}
	if (getftime(fhandle,&ftimep)==-1)
	{
		printf("Filetime can not be read.\n");
		close(fhandle);
		return(0);
	}
	close(fhandle);
	fdate.da_year=ftimep.ft_year+1980;
	fdate.da_mon=ftimep.ft_month;
	fdate.da_day=ftimep.ft_day;
	ftime.ti_hour=ftimep.ft_hour;
	ftime.ti_min=ftimep.ft_min;
	ftime.ti_sec=ftimep.ft_tsec;
	ftime.ti_hund=0;
	filetime=dostounix(&fdate,&ftime);		/* filetime naar seconden */
	fileage=time(&timer)-filetime;
	days=(fileage+42200l)/(86400l);			/* seconden naar dagen */
	hours=(fileage+1800l)/(3600l);			/* uren */
	minutes=(fileage+30l)/(60l);           /* minuten */
	switch(smhd)
	{
		case	1:	age=hours;		strcpy(s,"hours");	break;
		case	2:	age=minutes;   strcpy(s,"minutes");	break;
		case	3:	age=fileage;   strcpy(s,"seconds");	break;
		case	0:
		default:	age=days;      strcpy(s,"days");		break;
	}
	sprintf(formatstring,"%cs is %c%dld %cs old.\n",'%','%',numberlength,'%');
	printf(formatstring,argv[n+1],age,s);
//	printf("%s is %9ld %s old.\n",argv[n+1],age,s);
	if (argc>2+n)
	{
		log=fopen(argv[2+n],"at");
		if (log!=NULL)
		{
			fprintf(log,"----------  GETAGE %s\n",VERSION);
			gettime(&ftime);
			fprintf(log,"# %2d:%02d:%02d  %s is %ld %s old.\n",
					ftime.ti_hour,ftime.ti_min,ftime.ti_sec,argv[n+1],age,s);
			fclose(log);
		}
		else printf("failed to open logfile.\n");
	}
	return((int)(min(age,MAXINT)));
}
